<id>
Recent posts user preference
</id>

<version>
1.0
</version>

<mod info>
Per user customization of recent forum posts
</mod info>

<author>
miseryshining
</author>

<homepage>
http://simplemachines.org
</homepage>

<edit file>
/Themes/default/languages/Profile.english.php
</edit file>
<search for>
$txt['no_buddies'] = 'Your buddy list is currently empty';
</search for>
<add after>

$txt['RP_title'] = 'Recent posts settings';
$txt['RP_info'] = 'Here you can setup preferences for the recent post box.';
$txt['RP_lastOnly'] = 'Only show the last reply of a thread';
$txt['RP_nrofPosts'] = 'Number of posts to show';
$txt['RP_recentPosts'] = $txt['recentPosts'] = 'Recent posts preferences';
$txt['RP_listheader'] = 'check the boards you want to monitor';
</add after>

<edit file>
/Sources/Load.php
</edit file>

<search for>
	// Set up the $user_info array.
	$user_info += array(
</search for>
<add after>
		'recentPosts' => array('boards' => (!empty($user_settings['recentpostBoards']) ? explode(',',$user_settings['recentpostBoards']) : array()), 'lastOnly' => (!empty($user_settings['recentLastOnly']) ? 1 : "NULL"), 'nrofPosts' => (!empty($user_settings['recentNrofPosts']) ? $user_settings['recentNrofPosts']  : "10")),
</add after>

<search for>
	// Set up the contextual user array.
	$context['user'] = array(
</search for>
<add after>
		'recentPosts' => &$user_info['recentPosts'],
</add after>

<edit file>
/SSI.php
</edit file>

<search for>
// Recent post list:   [board] Subject by Poster	Date
function ssi_recentPosts($num_recent = 8, $exclude_boards = null, $output_method = 'echo')
</search for>
<add before>
// Recent posts & topics user preference: 	[board] Subject by Poster	Date
function ssi_recentPostsPref()
{
	global $context;
	if ($context['user']['recentPosts']['lastOnly'] == 1)
		ssi_recentTopics($context['user']['recentPosts']['nrofPosts'], null, 'echo', $context['user']['recentPosts']['boards']);
	else 
		ssi_recentPosts($context['user']['recentPosts']['nrofPosts'], null, 'echo', $context['user']['recentPosts']['boards']);
}

</add before>
<replace>
function ssi_recentPosts($num_recent = 8, $exclude_boards = null, $output_method = 'echo', $include_boards = null)
</replace>

<search for>
function ssi_recentTopics($num_recent = 8, $exclude_boards = null, $output_method = 'echo')
</search for>
<replace>
function ssi_recentTopics($num_recent = 8, $exclude_boards = null, $output_method = 'echo', $include_boards = null)
</replace>

<search for>
	// Find all the posts in distinct topics.  Newer ones will have higher IDs.
</search for>
<add before>
	if ($output_method == 'context_recent') {
		// get all the extra information about topics, so we can send them to Recent.template.php later
		$extravalues = "ms.subject AS firstSubject, ms.posterTime AS firstPosterTime, ms.ID_TOPIC, t.ID_BOARD, b.name AS bname,
		t.numReplies, t.numViews, ms.ID_MEMBER AS ID_FIRST_MEMBER, m.ID_MEMBER AS ID_LAST_MEMBER,
		m.posterTime AS lastPosterTime, ms.posterName AS firstPosterName,
		m.posterName AS lastPosterName, m.subject AS lastSubject,
		m.icon AS lastIcon, ms.icon AS firstIcon, t.ID_POLL, t.isSticky, t.locked, m.modifiedTime AS lastModifiedTime, 
		" . (!$user_info['is_guest'] ? "
		IFNULL(lt.ID_MSG, IFNULL(lmr.ID_MSG, -1)) + 1 AS new_from," : '') . " LEFT(m.body, 384) AS lastBody, LEFT(ms.body, 384) AS firstBody,
		m.smileysEnabled AS lastSmileys, ms.smileysEnabled AS firstSmileys, t.ID_FIRST_MSG, t.ID_LAST_MSG, ";
	}
	
</add before>

<search for>
	// Find all the posts in distinct topics.  Newer ones will have higher IDs.
	$request = db_query("
		SELECT
</search for>
<add after>
 {$extravalues}
</add after>

<search for>
			AND b.ID_BOARD NOT IN (" . implode(', ', $exclude_boards) . ")") . "
</search for>
<replace>
			AND b.ID_BOARD NOT IN (" . implode(', ', $exclude_boards) . ")") . (!empty($include_boards) ? "
			AND b.ID_BOARD IN (" . implode(', ', $include_boards) . ")"  : '')."
</replace>

<search for>
	while ($row = mysql_fetch_assoc($request))
	{
		$row['body'] = strip_tags(strtr(parse_bbc($row['body'], $row['smileysEnabled'], $row['ID_MSG']), array('<br />' => '&#10;')));
		if ($func['strlen']($row['body']) > 128)
			$row['body'] = $func['substr']($row['body'], 0, 128) . '...';

		// Censor the subject.
		censorText($row['subject']);
		censorText($row['body']);

		if (empty($modSettings['messageIconChecks_disable']) && !isset($icon_sources[$row['icon']]))
			$icon_sources[$row['icon']] = file_exists($settings['theme_dir'] . '/images/post/' . $row['icon'] . '.gif') ? 'images_url' : 'default_images_url';

		// Build the array.
		$posts[] = array(
			'board' => array(
				'id' => $row['ID_BOARD'],
				'name' => $row['bName'],
				'href' => $scripturl . '?board=' . $row['ID_BOARD'] . '.0',
				'link' => '<a href="' . $scripturl . '?board=' . $row['ID_BOARD'] . '.0">' . $row['bName'] . '</a>'
			),
			'topic' => $row['ID_TOPIC'],
			'poster' => array(
				'id' => $row['ID_MEMBER'],
				'name' => $row['posterName'],
				'href' => empty($row['ID_MEMBER']) ? '' : $scripturl . '?action=profile;u=' . $row['ID_MEMBER'],
				'link' => empty($row['ID_MEMBER']) ? $row['posterName'] : '<a href="' . $scripturl . '?action=profile;u=' . $row['ID_MEMBER'] . '">' . $row['posterName'] . '</a>'
			),
			'subject' => $row['subject'],
			'short_subject' => shorten_subject($row['subject'], 25),
			'preview' => $row['body'],
			'time' => timeformat($row['posterTime']),
			'timestamp' => forum_time(true, $row['posterTime']),
			'href' => $scripturl . '?topic=' . $row['ID_TOPIC'] . '.msg' . $row['ID_MSG'] . ';topicseen#new',
			'link' => '<a href="' . $scripturl . '?topic=' . $row['ID_TOPIC'] . '.msg' . $row['ID_MSG'] . '#new">' . $row['subject'] . '</a>',
			'new' => !empty($row['isRead']),
			'new_from' => $row['new_from'],
			'icon' => '<img src="' . $settings[$icon_sources[$row['icon']]] . '/post/' . $row['icon'] . '.gif" align="middle" alt="' . $row['icon'] . '" border="0" />',
		);
	}
</search for>
<replace>
	while ($row = mysql_fetch_assoc($request))
	{
		// this puts the extended topic information into $context['topics']. it's copied from Recent.php and can be used by template_unread() in Recent.template.php
		if ($output_method == 'context_recent') { 
			if ($row['ID_POLL'] > 0 && $modSettings['pollMode'] == '0')
				continue;
	
			$topic_ids[] = $row['ID_TOPIC'];
	
			// Clip the strings first because censoring is slow :/. (for some reason?)
			$row['firstBody'] = strip_tags(strtr(parse_bbc($row['firstBody'], $row['firstSmileys'], $row['ID_FIRST_MSG']), array('<br />' => '&#10;')));
			if ($func['strlen']($row['firstBody']) > 128)
				$row['firstBody'] = $func['substr']($row['firstBody'], 0, 128) . '...';
			$row['lastBody'] = strip_tags(strtr(parse_bbc($row['lastBody'], $row['lastSmileys'], $row['ID_LAST_MSG']), array('<br />' => '&#10;')));
			if ($func['strlen']($row['lastBody']) > 128)
				$row['lastBody'] = $func['substr']($row['lastBody'], 0, 128) . '...';
	
			// Do a bit of censoring...
			censorText($row['firstSubject']);
			censorText($row['firstBody']);
	
			// But don't do it twice, it can be a slow ordeal!
			if ($row['ID_FIRST_MSG'] == $row['ID_LAST_MSG'])
			{
				$row['lastSubject'] = $row['firstSubject'];
				$row['lastBody'] = $row['firstBody'];
			}
			else
			{
				censorText($row['lastSubject']);
				censorText($row['lastBody']);
			}
	
			// Decide how many pages the topic should have.
			$topic_length = $row['numReplies'] + 1;
			if ($topic_length > $modSettings['defaultMaxMessages'])
			{
				$tmppages = array();
				$tmpa = 1;
				for ($tmpb = 0; $tmpb < $topic_length; $tmpb += $modSettings['defaultMaxMessages'])
				{
					$tmppages[] = '<a href="' . $scripturl . '?topic=' . $row['ID_TOPIC'] . '.' . $tmpb . ';topicseen">' . $tmpa . '</a>';
					$tmpa++;
				}
				// Show links to all the pages?
				if (count($tmppages) <= 5)
					$pages = '&#171; ' . implode(' ', $tmppages);
				// Or skip a few?
				else
					$pages = '&#171; ' . $tmppages[0] . ' ' . $tmppages[1] . ' ... ' . $tmppages[count($tmppages) - 2] . ' ' . $tmppages[count($tmppages) - 1];
	
				if (!empty($modSettings['enableAllMessages']) && $topic_length < $modSettings['enableAllMessages'])
					$pages .= ' &nbsp;<a href="' . $scripturl . '?topic=' . $row['ID_TOPIC'] . '.0;all">' . $txt[190] . '</a>';
				$pages .= ' &#187;';
			}
			else
				$pages = '';
	
			// We need to check the topic icons exist... you can never be too sure!
			if (empty($modSettings['messageIconChecks_disable']))
			{
				// First icon first... as you'd expect.
				if (!isset($context['icon_sources'][$row['firstIcon']]))
					$context['icon_sources'][$row['firstIcon']] = file_exists($settings['theme_dir'] . '/images/post/' . $row['firstIcon'] . '.gif') ? 'images_url' : 'default_images_url';
				// Last icon... last... duh.
				if (!isset($context['icon_sources'][$row['lastIcon']]))
					$context['icon_sources'][$row['lastIcon']] = file_exists($settings['theme_dir'] . '/images/post/' . $row['lastIcon'] . '.gif') ? 'images_url' : 'default_images_url';
			}
	
			// And build the array.
			$context['topics'][$row['ID_TOPIC']] = array(
				'id' => $row['ID_TOPIC'],
				'first_post' => array(
					'id' => $row['ID_FIRST_MSG'],
					'member' => array(
						'name' => $row['firstPosterName'],
						'id' => $row['ID_FIRST_MEMBER'],
						'href' => $scripturl . '?action=profile;u=' . $row['ID_FIRST_MEMBER'],
						'link' => !empty($row['ID_FIRST_MEMBER']) ? '<a href="' . $scripturl . '?action=profile;u=' . $row['ID_FIRST_MEMBER'] . '" title="' . $txt[92] . ' ' . $row['firstPosterName'] . '">' . $row['firstPosterName'] . '</a>' : $row['firstPosterName']
					),
					'time' => timeformat($row['firstPosterTime']),
					'timestamp' => forum_time(true, $row['firstPosterTime']),
					'subject' => $row['firstSubject'],
					'preview' => $row['firstBody'],
					'icon' => $row['firstIcon'],
					'icon_url' => $settings[$context['icon_sources'][$row['firstIcon']]] . '/post/' . $row['firstIcon'] . '.gif',
					'href' => $scripturl . '?topic=' . $row['ID_TOPIC'] . '.0;topicseen',
					'link' => '<a href="' . $scripturl . '?topic=' . $row['ID_TOPIC'] . '.0;topicseen">' . $row['firstSubject'] . '</a>'
				),
				'last_post' => array(
					'id' => $row['ID_LAST_MSG'],
					'member' => array(
						'name' => $row['lastPosterName'],
						'id' => $row['ID_LAST_MEMBER'],
						'href' => $scripturl . '?action=profile;u=' . $row['ID_LAST_MEMBER'],
						'link' => !empty($row['ID_LAST_MEMBER']) ? '<a href="' . $scripturl . '?action=profile;u=' . $row['ID_LAST_MEMBER'] . '">' . $row['lastPosterName'] . '</a>' : $row['lastPosterName']
					),
					'time' => timeformat($row['lastPosterTime']),
					'timestamp' => forum_time(true, $row['lastPosterTime']),
					'subject' => $row['lastSubject'],
					'preview' => $row['lastBody'],
					'icon' => $row['lastIcon'],
					'icon_url' => $settings[$context['icon_sources'][$row['lastIcon']]] . '/post/' . $row['lastIcon'] . '.gif',
					'href' => $scripturl . '?topic=' . $row['ID_TOPIC'] . ($row['numReplies'] == 0 ? '.0' : '.msg' . $row['ID_LAST_MSG']) . ';topicseen#msg' . $row['ID_LAST_MSG'],
					'link' => '<a href="' . $scripturl . '?topic=' . $row['ID_TOPIC'] . ($row['numReplies'] == 0 ? '.0' : '.msg' . $row['ID_LAST_MSG']) . ';topicseen#msg' . $row['ID_LAST_MSG'] . '">' . $row['lastSubject'] . '</a>'
				),
				'new_from' => $row['new_from'],
				'new_href' => $scripturl . '?topic=' . $row['ID_TOPIC'] . '.msg' . $row['new_from'] . ';topicseen#new',
				'href' => $scripturl . '?topic=' . $row['ID_TOPIC'] . ($row['numReplies'] == 0 ? '.0' : '.msg' . $row['new_from']) . ';topicseen' . ($row['numReplies'] == 0 ? '' : 'new'),
				'link' => '<a href="' . $scripturl . '?topic=' . $row['ID_TOPIC'] . ($row['numReplies'] == 0 ? '.0' : '.msg' . $row['new_from']) . ';topicseen#msg' . $row['new_from'] . '">' . $row['firstSubject'] . '</a>',
				'is_read' => $row['isRead'],
				'is_sticky' => !empty($modSettings['enableStickyTopics']) && !empty($row['isSticky']),
				'is_locked' => !empty($row['locked']),
				'is_poll' => $modSettings['pollMode'] == '1' && $row['ID_POLL'] > 0,
				'is_hot' => $row['numReplies'] >= $modSettings['hotTopicPosts'],
				'is_very_hot' => $row['numReplies'] >= $modSettings['hotTopicVeryPosts'],
				'is_posted_in' => false,
				'icon' => $row['firstIcon'],
				'icon_url' => $settings[$context['icon_sources'][$row['firstIcon']]] . '/post/' . $row['firstIcon'] . '.gif',
				'subject' => $row['firstSubject'],
				'pages' => $pages,
				'replies' => $row['numReplies'],
				'views' => $row['numViews'],
				'board' => array(
					'id' => $row['ID_BOARD'],
					'name' => $row['bname'],
					'href' => $scripturl . '?board=' . $row['ID_BOARD'] . '.0',
					'link' => '<a href="' . $scripturl . '?board=' . $row['ID_BOARD'] . '.0">' . $row['bname'] . '</a>'
				)
			);
	
			determineTopicClass($context['topics'][$row['ID_TOPIC']]);
		}
		else {
			$row['body'] = strip_tags(strtr(parse_bbc($row['body'], $row['smileysEnabled'], $row['ID_MSG']), array('<br />' => '&#10;')));
			if ($func['strlen']($row['body']) > 128)
				$row['body'] = $func['substr']($row['body'], 0, 128) . '...';
	
			// Censor the subject.
			censorText($row['subject']);
			censorText($row['body']);
	
			if (empty($modSettings['messageIconChecks_disable']) && !isset($icon_sources[$row['icon']]))
				$icon_sources[$row['icon']] = file_exists($settings['theme_dir'] . '/images/post/' . $row['icon'] . '.gif') ? 'images_url' : 'default_images_url';
	
			// Build the array.
			$posts[] = array(
				'board' => array(
					'id' => $row['ID_BOARD'],
					'name' => $row['bName'],
					'href' => $scripturl . '?board=' . $row['ID_BOARD'] . '.0',
					'link' => '<a href="' . $scripturl . '?board=' . $row['ID_BOARD'] . '.0">' . $row['bName'] . '</a>'
				),
				'topic' => $row['ID_TOPIC'],
				'poster' => array(
					'id' => $row['ID_MEMBER'],
					'name' => $row['posterName'],
					'href' => empty($row['ID_MEMBER']) ? '' : $scripturl . '?action=profile;u=' . $row['ID_MEMBER'],
					'link' => empty($row['ID_MEMBER']) ? $row['posterName'] : '<a href="' . $scripturl . '?action=profile;u=' . $row['ID_MEMBER'] . '">' . $row['posterName'] . '</a>'
				),
				'subject' => $row['subject'],
				'short_subject' => shorten_subject($row['subject'], 25),
				'preview' => $row['body'],
				'time' => timeformat($row['posterTime']),
				'timestamp' => forum_time(true, $row['posterTime']),
				'href' => $scripturl . '?topic=' . $row['ID_TOPIC'] . '.msg' . $row['ID_MSG'] . ';topicseen#new',
				'link' => '<a href="' . $scripturl . '?topic=' . $row['ID_TOPIC'] . '.msg' . $row['ID_MSG'] . '#new">' . $row['subject'] . '</a>',
				'new' => !empty($row['isRead']),
				'new_from' => $row['new_from'],
				'icon' => '<img src="' . $settings[$icon_sources[$row['icon']]] . '/post/' . $row['icon'] . '.gif" align="middle" alt="' . $row['icon'] . '" border="0" />',
			);
		}
	}
</replace>


<edit file>
/Sources/Profile.php
</edit file>

<search for>
		'theme' => array(array('profile_extra_any', 'profile_extra_own'), array('profile_extra_any')),
</search for>
<add after>
		'recentPosts' => array(array('profile_extra_any', 'profile_extra_own'), array('profile_extra_any')),
</add after>

<search for>
			$context['profile_areas']['edit_profile']['areas']['theme'] = '<a href="' . $scripturl . '?action=profile;u=' . $memID . ';sa=theme">' . $txt['theme'] . '</a>';
</search for>
<add after>
			$context['profile_areas']['edit_profile']['areas']['recentPosts'] = '<a href="' . $scripturl . '?action=profile;u=' . $memID . ';sa=recentPosts">' . $txt['RP_recentPosts'] . '</a>';
</add after>

<search for>
		'theme' => array(array('profile_extra_any', 'profile_extra_own'), array('profile_extra_any'), 'post'),
</search for>
<add after>
		'recentPosts' => array(array('profile_extra_any', 'profile_extra_own'), array('profile_extra_any'), 'post'),
</add after>

<search for>
		makeThemeChanges($memID, isset($_POST['ID_THEME']) ? (int) $_POST['ID_THEME'] : $old_profile['ID_THEME']);
</search for>
<add after>
		makeRecentPostsChanges($memID);
</add after>

<search for>
// Make any notification changes that need to be made.
function makeNotificationChanges($memID)
</search for>
<add before>
// Make any recent board changes that are sent with the profile..
function makeRecentPostsChanges($memID)
{
	global $db_prefix, $modSettings;

	//recent posts settings are changed
	if (isset($_POST['sa']) && $_POST['sa'] == 'recentPosts') {
		$boardRecentStr = implode(',', $_POST['boardRecent']);
		if (!$boardRecentStr) $boardRecentStr = 0;
		if (isset($_POST['lastOnly']))
			$recentLastOnly = 1; 
		else $recentLastOnly = 0;
		if (empty($_POST['nrofPosts'])) $_POST['nrofPosts'] = 10;
	
		db_query("
			UPDATE {$db_prefix}members 
			SET recentpostBoards = '{$boardRecentStr}',
			recentLastOnly = $recentLastOnly,
			recentNrofPosts = {$_POST['nrofPosts']}
			WHERE ID_MEMBER = {$memID} LIMIT 1", __FILE__, __LINE__);
	}
}

</add before>

<search for>
// Display the notifications and settings for changes.
function notification($memID)
</search for>
<add before>
function recentPosts($memID)
{
	global $txt, $context, $user_profile, $db_prefix, $modSettings, $settings, $user_info, $ID_MEMBER;

	//select user preference if $memID != user ID. 
	if ($ID_MEMBER != $memID) {
		$result = db_query("SELECT recentpostBoards, recentLastOnly, recentNrofPosts FROM {$db_prefix}members WHERE ID_MEMBER = {$memID} LIMIT 1", __FILE__, __LINE__);
		$row = mysql_fetch_assoc($result);
		$context['user']['recentPosts']['boards'] = !empty($row['recentpostBoards']) ? explode(',',$row['recentpostBoards']) : array();
		$context['user']['recentPosts']['lastOnly'] = !empty($row['recentLastOnly']) ? 1 : "NULL";
		$context['user']['recentPosts']['nrofPosts'] = !empty($row['recentNrofPosts']) ? $row['recentNrofPosts'] : "10";
	}
	

	$recentpostBoards = $context['user']['recentPosts']['boards'];

	$result = db_query("
		SELECT ID_GROUP, groupName
		FROM {$db_prefix}membergroups
		WHERE (ID_GROUP > 3 OR ID_GROUP = 2)" . (empty($modSettings['permission_enable_postgroups']) ? "
			AND minPosts = -1" : '') . "
		ORDER BY minPosts, ID_GROUP != 2, groupName", __FILE__, __LINE__);
	$context['groups'] = array();
	while ($row = mysql_fetch_assoc($result))
		$context['groups'][] = array(
			'id' => $row['ID_GROUP'],
			'name' => $row['groupName']
		);
	mysql_free_result($result);
		
	$result_boards = db_query("
		SELECT
			b.ID_BOARD, b.name AS boardName, b.childlevel, b.description,
			b.numPosts, b.numTopics, b.ID_PARENT
		FROM {$db_prefix}boards AS b
		WHERE $user_info[query_see_board]" . (empty($modSettings['countChildPosts']) ? "
			AND b.childLevel <= 1" : ''), __FILE__, __LINE__);

		$context['boards'] = array();
		while ($row = mysql_fetch_assoc($result_boards))
		$context['boards'][] = array(
			'id' => $row['ID_BOARD'],
			'name' => $row['boardName'],
			'child_level' => $row['childlevel'],
			'selected' => false,
			'monitor' => (in_array($row['ID_BOARD'],$recentpostBoards)) ? 1 : -1
		);
		mysql_free_result($result_boards);
	
	loadThemeOptions($memID);

	loadLanguage('Settings');
}

</add before>


<edit file>
/Themes/default/Profile.template.php
</edit file>

<search for>
function template_notification()
</search for>
<add before>
// Template for showing recent posts settings.
function template_recentPosts()
{
	global $context, $settings, $options, $scripturl, $modSettings, $txt, $user_info;
	
	if (!empty($context['boards']))
	{
		echo '
			<table border="0" width="85%" cellspacing="1" cellpadding="4" align="center" class="bordercolor">
				<tr class="titlebg">
					<td height="26">
						&nbsp;<img src="', $settings['images_url'], '/icons/profile_sm.gif" alt="" border="0" align="top" />&nbsp;
						' . $txt['RP_title'] . '
					</td>
				</tr><tr class="windowbg">
					<td class="smalltext" height="25" style="padding: 2ex;">
						' . $txt['RP_info'] . '
					</td>
				</tr><tr>
				<td class="windowbg2" style="padding-bottom: 2ex;">
				<form action="', $scripturl, '?action=profile2" method="post" accept-charset="', $context['character_set'], '" style="margin: 0;">
				<table border="0" width="100%" cellpadding="3">
				  	<tr class="windowbg2">
					<td valign="top">
						<fieldset>
						<legend>',$txt['RP_listheader'],'</legend>';
						foreach ($context['boards'] as $board) {
							echo '<div style="margin-left: ', $board['child_level'], 'em;"><input type="checkbox" name="boardRecent[]" id="boardaccess_', $board['id'], '" value="', $board['id'], '" ', $board['monitor'] == 1 ? ' checked="checked"' : '', ' class="check" /> <label for="boardaccess_', $board['id'], '">', $board['name'], '</label></div>';
						}

		echo '<br />
							<input type="checkbox" id="checkall_check" class="check" onclick="invertAll(this, this.form, \'boardRecent\');" /> <label for="checkall_check"><i>', $txt[737], '</i></label>
						</fieldset>
					</td>
				</tr>
				<tr class="windowbg2">
				<td valign="top"><input type="checkbox" class="check" name="lastOnly" id="lastOnly" ', $context['user']['recentPosts']['lastOnly'] == 1 ? 'checked="checked"': '',' /><label for="lastOnly">' . $txt['RP_lastOnly'] . '</label></td>
				</tr>
				<tr class="windowbg2">
				<td valign="top"><label for="nrofPosts">' . $txt['RP_nrofPosts'] . '</label>&nbsp;
				<select name="nrofPosts" />
				<option ',($context['user']['recentPosts']['nrofPosts'] == 5 ? 'SELECTED' : ''),'>5</option>
				<option ',($context['user']['recentPosts']['nrofPosts'] == 10 || !isset($context['user']['recentPosts']['nrofPosts']) ? 'SELECTED' : ''),'>10</option>
				<option ',($context['user']['recentPosts']['nrofPosts'] == 15 ? 'SELECTED' : ''),'>15</option>
				<option ',($context['user']['recentPosts']['nrofPosts'] == 20 ? 'SELECTED' : ''),'>20</option>
				<option ',($context['user']['recentPosts']['nrofPosts'] == 25 ? 'SELECTED' : ''),'>25</option>
				</select>
				</td>
				</tr>
				<tr class="windowbg2">
				<td valign="top">', 				
				template_profile_save(),'
				</td>
				</tr></table>
				</form>
				</td>
			</tr></table>
				';
	}
}

</add before>


<edit file>
/Sources/Recent.php
</edit file>

<search for>
?>
</search for>
<add before>

// get xx recent topics (read or unread) from ssi_recentTopics and call the unread template to display them nicely
function RecentTopics() {
	global $context, $settings, $txt;
	require_once('SSI.php');
	ssi_recentTopics(isset($_GET['count']) && $_GET['count'] <= 50 ? $_GET['count'] : 30, null, 'context_recent', isset($_GET['all']) ? NULL : $context['user']['recentPosts']['boards']);
	$settings['show_mark_read'] = FALSE;
	$context['page_index'] = 1;
	$txt['unread_topics_all'] = 'show unread only';
	loadTemplate('Recent');
	$context['sub_template'] = 'unread';
}

</add before>


<edit file>
/Themes/default/Recent.template.php
</edit file>

<search for>
						<img src="' . $settings['images_url'] . '/icons/show_sticky.gif" align="right" alt="" style="margin: 0;" />' : '', $topic['first_post']['link'], ' <a href="', $topic['new_href'], '"><img src="', $settings['images_url'], '/', $context['user']['language'], '/new.gif" alt="', $txt[302], '" /></a> <span class="smalltext">', $topic['pages'], ' ', $txt['smf88'], ' ', $topic['board']['link'], '</span></td>
</search for>
<replace>
						<img src="' . $settings['images_url'] . '/icons/show_sticky.gif" align="right" alt="" style="margin: 0;" />' : '', $topic['first_post']['link'], $topic['is_read'] == 0 ? ' <a href="'. $topic['new_href']. '"><img src="'. $settings['images_url']. '/'. $context['user']['language']. '/new.gif" alt="'. $txt[302]. '" /></a>' : '', '<span class="smalltext">', $topic['pages'], ' ', $txt['smf88'], ' ', $topic['board']['link'], '</span></td>
</replace>


<edit file>
/index.php
</edit file>

<search for>
		'recent' => array('Recent.php', 'RecentPosts'),
</search for>
<add after>
		'recenttopics' => array('Recent.php', 'RecentTopics'),
</add after>
